Subject: Integrate StGIT into Git? (Was: Re: Using StGIT for tweaking already-committed stuff)

From: Jan Hudec <[email-masked]>
Date: Fri, 11 May 2007 07:48:07 +0200

Hello Folks,

On Thu, May 10, 2007 at 14:16:43 -0700, Carl Worth wrote:
> I'll try again.
> 
> I like the git user interface. I like it a lot. (It's got a couple of
> tiny things that I would do differently if I could start over, but
> more importantly it has a lot of big things that I wouldn't have even
> thought of if I had started from scratch.)
> 
> But with respect to the current topic, there are a couple of features
> that the git interface is missing compared to something like stg:
> 
> 1. Amend a commit that's somewhere besides the tip of a branch,
>    (rebuilding every commit that follows)
> 
> 2. Re-ordering commits that exist on a branch, (again, rebuilding
>    every commit that follows).

I would actually propose to (gradually) add stg functionality into git. If it
was done in stgit-compatible fashion, it would allow using stgit for the bits
still not ported to git and switching back and forth according to user's
taste.

Many commands from stgit either already have git equivalent or do just
a little work beyond what the git command already does, so they could be
easily integrated.

> [...]
> I'd just love to see something more minimal, and incorporated into git
> itself, to address the missing functionality. Right now, "cherry-pick
> A..B" is all I have to suggest. But maybe later there could be some
> sort of push/pop addition as well, (except that obviously the name
> "push" isn't available as a sub-command).

I think that many of them would be actually pretty simple.

-- 
						 Jan 'Bulb' Hudec <[email-masked]>